use super::{addresses::Addresses, *};

pub(super) struct DeCtxT<'a: 'c, 'c, Ctx: Context<'a>> {
    pub(super) deserializer: &'c mut dyn Deserializer,
    pub(super) resolver: &'c Arc<dyn Resolver<'a, Ctx>>,
    pub(super) addresses: &'c mut Addresses,
}

pub(super) trait DeCtx<'a, Ctx: Context<'a>> {
    fn deserializer(&mut self) -> &mut dyn Deserializer;

    fn tell(&self) -> usize;

    fn resolver(&self) -> Arc<dyn Resolver<'a, Ctx>>;

    fn ad(&mut self) -> (&mut Addresses, &mut dyn Deserializer);
}

impl<'a: 'c, 'c, Ctx: Context<'a>> DeCtx<'a, Ctx> for DeCtxT<'a, 'c, Ctx> {
    fn deserializer(&mut self) -> &mut dyn Deserializer {
        self.deserializer
    }

    fn tell(&self) -> usize {
        self.deserializer.tell()
    }

    fn resolver(&self) -> Arc<dyn Resolver<'a, Ctx>> {
        self.resolver.clone()
    }

    fn ad(&mut self) -> (&mut Addresses, &mut dyn Deserializer) {
        (self.addresses, self.deserializer)
    }
}
